#include <iostream>

using namespace std;

int main()
{
    long long n,h;

    cin>>h;
    cin>>n;
    bool mat[h][n];
    long niz[n];
    for(int i=0;i<h;i++)
        for(int j=0;j<n;j++)
            cin>>mat[i][j];
    //gde se ukuca 0 tu je kamen i bice vrednost false

    for(int j=0;j<n;j++)
        niz[j]=1;

      for(int i=0;i<h;i++)
      {
        for(int j=0;j<n;j++)
        {

            if(mat[i][j])
                continue;
            int k;
            for(k=j+1;k<n&& !mat[i][k];k++);


            if(j==0)
            {
                for(int p=j;p<k;p++)
                {
                    niz[k]+=niz[p];
                    niz[p]=0;
                }
                j=k-1;
                continue;
            }

            if(k==n)
                {
                    for(int p=k-1;p>=j;p--)
                    {
                        niz[j-1]+=niz[p];
                        niz[p]=0;
                    }
                    j=k-1;
                    continue;
                }

            int zb=0;

            for(int p=j;p<k;p++)
            {
                zb+=niz[p];
                niz[p]=0;
            }

            niz[j-1]+=zb/2;
            niz[k]+=zb/2;

            if(i%2==1)
                niz[k]+=zb-(zb/2)*2;
            else
                 niz[j-1]+=zb-(zb/2)*2;

            j=k-1;
        }
      }

      for(int j=0;j<n;j++)
        cout<<niz[j]<<" ";

}